/*
 * This file is generated by jOOQ.
 */
package nu.studer.sample.tables.records;


import java.sql.Date;
import java.util.UUID;

import javax.annotation.processing.Generated;

import nu.studer.sample.tables.Purpose;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record8;
import org.jooq.Row8;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * Таблица целей
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.15.1"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class PurposeRecord extends UpdatableRecordImpl<PurposeRecord> implements Record8<UUID, String, Date, Date, Date, Double, UUID, UUID> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>selfbooster.purpose.uuid</code>.
     */
    public PurposeRecord setUuid(UUID value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.purpose.uuid</code>.
     */
    public UUID getUuid() {
        return (UUID) get(0);
    }

    /**
     * Setter for <code>selfbooster.purpose.description</code>.
     */
    public PurposeRecord setDescription(String value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.purpose.description</code>.
     */
    public String getDescription() {
        return (String) get(1);
    }

    /**
     * Setter for <code>selfbooster.purpose.created_at</code>.
     */
    public PurposeRecord setCreatedAt(Date value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.purpose.created_at</code>.
     */
    public Date getCreatedAt() {
        return (Date) get(2);
    }

    /**
     * Setter for <code>selfbooster.purpose.desired_at</code>.
     */
    public PurposeRecord setDesiredAt(Date value) {
        set(3, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.purpose.desired_at</code>.
     */
    public Date getDesiredAt() {
        return (Date) get(3);
    }

    /**
     * Setter for <code>selfbooster.purpose.due_at</code>.
     */
    public PurposeRecord setDueAt(Date value) {
        set(4, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.purpose.due_at</code>.
     */
    public Date getDueAt() {
        return (Date) get(4);
    }

    /**
     * Setter for <code>selfbooster.purpose.percent_completion</code>. процент
     * выполнения
     */
    public PurposeRecord setPercentCompletion(Double value) {
        set(5, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.purpose.percent_completion</code>. процент
     * выполнения
     */
    public Double getPercentCompletion() {
        return (Double) get(5);
    }

    /**
     * Setter for <code>selfbooster.purpose.customer_uuid</code>.
     */
    public PurposeRecord setCustomerUuid(UUID value) {
        set(6, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.purpose.customer_uuid</code>.
     */
    public UUID getCustomerUuid() {
        return (UUID) get(6);
    }

    /**
     * Setter for <code>selfbooster.purpose.category_uuid</code>.
     */
    public PurposeRecord setCategoryUuid(UUID value) {
        set(7, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.purpose.category_uuid</code>.
     */
    public UUID getCategoryUuid() {
        return (UUID) get(7);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<UUID> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record8 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row8<UUID, String, Date, Date, Date, Double, UUID, UUID> fieldsRow() {
        return (Row8) super.fieldsRow();
    }

    @Override
    public Row8<UUID, String, Date, Date, Date, Double, UUID, UUID> valuesRow() {
        return (Row8) super.valuesRow();
    }

    @Override
    public Field<UUID> field1() {
        return Purpose.PURPOSE.UUID;
    }

    @Override
    public Field<String> field2() {
        return Purpose.PURPOSE.DESCRIPTION;
    }

    @Override
    public Field<Date> field3() {
        return Purpose.PURPOSE.CREATED_AT;
    }

    @Override
    public Field<Date> field4() {
        return Purpose.PURPOSE.DESIRED_AT;
    }

    @Override
    public Field<Date> field5() {
        return Purpose.PURPOSE.DUE_AT;
    }

    @Override
    public Field<Double> field6() {
        return Purpose.PURPOSE.PERCENT_COMPLETION;
    }

    @Override
    public Field<UUID> field7() {
        return Purpose.PURPOSE.CUSTOMER_UUID;
    }

    @Override
    public Field<UUID> field8() {
        return Purpose.PURPOSE.CATEGORY_UUID;
    }

    @Override
    public UUID component1() {
        return getUuid();
    }

    @Override
    public String component2() {
        return getDescription();
    }

    @Override
    public Date component3() {
        return getCreatedAt();
    }

    @Override
    public Date component4() {
        return getDesiredAt();
    }

    @Override
    public Date component5() {
        return getDueAt();
    }

    @Override
    public Double component6() {
        return getPercentCompletion();
    }

    @Override
    public UUID component7() {
        return getCustomerUuid();
    }

    @Override
    public UUID component8() {
        return getCategoryUuid();
    }

    @Override
    public UUID value1() {
        return getUuid();
    }

    @Override
    public String value2() {
        return getDescription();
    }

    @Override
    public Date value3() {
        return getCreatedAt();
    }

    @Override
    public Date value4() {
        return getDesiredAt();
    }

    @Override
    public Date value5() {
        return getDueAt();
    }

    @Override
    public Double value6() {
        return getPercentCompletion();
    }

    @Override
    public UUID value7() {
        return getCustomerUuid();
    }

    @Override
    public UUID value8() {
        return getCategoryUuid();
    }

    @Override
    public PurposeRecord value1(UUID value) {
        setUuid(value);
        return this;
    }

    @Override
    public PurposeRecord value2(String value) {
        setDescription(value);
        return this;
    }

    @Override
    public PurposeRecord value3(Date value) {
        setCreatedAt(value);
        return this;
    }

    @Override
    public PurposeRecord value4(Date value) {
        setDesiredAt(value);
        return this;
    }

    @Override
    public PurposeRecord value5(Date value) {
        setDueAt(value);
        return this;
    }

    @Override
    public PurposeRecord value6(Double value) {
        setPercentCompletion(value);
        return this;
    }

    @Override
    public PurposeRecord value7(UUID value) {
        setCustomerUuid(value);
        return this;
    }

    @Override
    public PurposeRecord value8(UUID value) {
        setCategoryUuid(value);
        return this;
    }

    @Override
    public PurposeRecord values(UUID value1, String value2, Date value3, Date value4, Date value5, Double value6, UUID value7, UUID value8) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        value7(value7);
        value8(value8);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached PurposeRecord
     */
    public PurposeRecord() {
        super(Purpose.PURPOSE);
    }

    /**
     * Create a detached, initialised PurposeRecord
     */
    public PurposeRecord(UUID uuid, String description, Date createdAt, Date desiredAt, Date dueAt, Double percentCompletion, UUID customerUuid, UUID categoryUuid) {
        super(Purpose.PURPOSE);

        setUuid(uuid);
        setDescription(description);
        setCreatedAt(createdAt);
        setDesiredAt(desiredAt);
        setDueAt(dueAt);
        setPercentCompletion(percentCompletion);
        setCustomerUuid(customerUuid);
        setCategoryUuid(categoryUuid);
    }

    /**
     * Create a detached, initialised PurposeRecord
     */
    public PurposeRecord(nu.studer.sample.tables.pojos.Purpose value) {
        super(Purpose.PURPOSE);

        if (value != null) {
            setUuid(value.getUuid());
            setDescription(value.getDescription());
            setCreatedAt(value.getCreatedAt());
            setDesiredAt(value.getDesiredAt());
            setDueAt(value.getDueAt());
            setPercentCompletion(value.getPercentCompletion());
            setCustomerUuid(value.getCustomerUuid());
            setCategoryUuid(value.getCategoryUuid());
        }
    }
}
